<template>
  <div class="something">
    <video
      id="videojs-player"
      class="video-js vjs-default-skin vjs-4-3 vjs-big-play-centered"
      controls
      autoplay
      playsinline
    />
  </div>
</template>

<script lang="ts">
import videojs from "video.js";
import {
  // VideoJSQualityPlugin,
  // VideoJSIVSTech,
  registerIVSQualityPlugin,
  registerIVSTech,
  // VideoJSEvents,
} from "amazon-ivs-player";

// @ts-ignore
import wasmBinaryPath from "amazon-ivs-player/dist/assets/amazon-ivs-wasmworker.min.wasm";
import wasmWorkerPath from "amazon-ivs-player/dist/assets/amazon-ivs-wasmworker.min.js";

export default {
  name: "something",
  mounted() {
    // register the tech with videojs
    registerIVSTech(videojs, {
      wasmWorker: new URL(wasmWorkerPath, document.URL).toString(),
      wasmBinary: new URL(wasmBinaryPath, document.URL).toString(),
    });

    // register the quality plugin
    registerIVSQualityPlugin(videojs);

    // create the player with the appropriate types. We're using @types/video.js VideoJsPlayer, and intersecting our Player and Quality Plugin interface
    const player = videojs(
      "videojs-player",
      {
        techOrder: ["AmazonIVS"],
        autoplay: true,
      },
      function() {
        console.warn("Player is ready to use");
      }
    );

    // enable the quality plugin
    player.enableIVSQualityPlugin();

    // listen to IVS specific events
    const events = player.getIVSEvents();
    const ivsPlayer = player.getIVSPlayer();
    ivsPlayer.addEventListener(events.PlayerState.PLAYING, () => {
      console.log("IVS Player is playing");
    });

    const liveStreamUrl =
      "https://fcc3ddae59ed.us-west-2.playback.live-video.net/api/video/v1/us-west-2.893648527354.channel.DmumNckWFTqz.m3u8";

    player.src(liveStreamUrl);
  },
};
</script>

<style lang="scss" scoped></style>
